stages:
    - testes
    - migrar
    - build
    - registro_docker
    - deploy

testar_login:
    image: docker:stable
    stage: testes
    script:
        - docker login $CI_REGISTRY -u kennynuylla -p $Token
    services:
        - docker:stable-dind
    only:
        - master
        - tags

testes_unitarios_dev:
    image: $SDKImage
    stage: testes
    script:
        - dotnet test -c DockerDebug
    only:
        - desenvolvimento

testes_unitarios_prod:
    image: $SDKImage
    stage: testes
    script:
        - dotnet test -c Release
    only:
        - master
        - tags

migrar_prod:
    image: $SDKImage
    stage: migrar
    script:
        - dotnet tool install --global dotnet-ef
        - export PATH="$PATH:/root/.dotnet/tools"
        - dotnet restore Infraestrutura/Infraestrutura.csproj
        - dotnet-ef database update -p Infraestrutura/Infraestrutura.csproj --configuration Release
    only:
        - master

migrar_dev:
    image: $SDKImage
    stage: migrar
    script:
        - dotnet tool install --global dotnet-ef
        - export PATH="$PATH:/root/.dotnet/tools"
        - dotnet restore Infraestrutura/Infraestrutura.csproj
        - dotnet-ef database update -p Infraestrutura/Infraestrutura.csproj --configuration DockerDebug
    only:
        - desenvolvimento
        
build-prod:
    image: $SDKImage
    stage: build
    script:
        - dotnet publish BoiunaSite/BoiunaSite.csproj -c Release -o BoiunaSite/app
    artifacts:
        paths:
            - BoiunaSite/app
    only:
        - master
        - tags

build-dev:
    image: $SDKImage
    stage: build
    script:
        - dotnet publish BoiunaSite/BoiunaSite.csproj -c DockerDebug -o BoiunaSite/app
    artifacts:
        paths:
            - BoiunaSite/app
    only:
        - desenvolvimento


registro-master:
    image: docker:stable
    stage: registro_docker
    script:
        - docker login $CI_REGISTRY -u kennynuylla -p $Token
        - docker build -t $CI_REGISTRY/trabalho3/pref-porto/boiunatech BoiunaSite/
        - docker push $CI_REGISTRY/trabalho3/pref-porto/boiunatech
    only:
        - master
    services:
        - docker:stable-dind

registro-dev:
    image: docker:stable
    stage: registro_docker
    script:
        - docker login $CI_REGISTRY -u kennynuylla -p $Token
        - docker build -t $CI_REGISTRY/trabalho3/pref-porto/boiunatech:dev BoiunaSite/
        - docker push $CI_REGISTRY/trabalho3/pref-porto/boiunatech:dev
    only:
        - desenvolvimento
    services:
        - docker:stable-dind


registro-tag:
    image: docker:stable
    stage: registro_docker
    script:
        - docker login $CI_REGISTRY -u kennynuylla -p $Token
        - docker build -t $CI_REGISTRY/trabalho3/pref-porto/boiunatech:$CI_COMMIT_TAG BoiunaSite/
        - docker push $CI_REGISTRY/trabalho3/pref-porto/boiunatech:$CI_COMMIT_TAG
    only:
        - tags
    services:
        - docker:stable-dind


deploy-prod:
    stage: deploy
    only:
        - master
    tags:
        - boiunarunner
    script:
        - echo "Servidor=$Servidor" >> .env
        - echo "Usuario=$Usuario" >> .env
        - echo "SenhaMySQLBoiuna=$SenhaMySQLBoiuna" >> .env
        - echo "BancoDeDados=$BancoDeDados" >> .env
        - echo "LoginAdminBoiuna=$LoginAdminBoiuna" >> .env
        - echo "SenhaAdminBoiuna=$SenhaAdminBoiuna" >> .env
        - echo "ServidorEmail=$ServidorEmail" >> .env
        - echo "ServidorEmailPorta=$ServidorEmailPorta" >> .env
        - echo "SenhaServidorEmail=$SenhaServidorEmail" >> .env
        - echo "UsuarioServidorEmail=$UsuarioServidorEmail" >> .env
        - sudo docker-compose -f $ComposeDir/docker-compose.boiuna.yml --env-file ./.env down
        - sudo docker-compose -f $ComposeDir/docker-compose.boiuna.yml --env-file ./.env pull
        - sudo docker-compose -f $ComposeDir/docker-compose.boiuna.yml --env-file ./.env up -d

deploy-dev:
    stage: deploy
    only:
        - desenvolvimento
    tags:
        - boiunarunner
    script:
        - ((docker stop BoiunaDev && docker rm BoiunaDev) &> /dev/null) || true
        - docker pull registry.gitlab.com/trabalho3/pref-porto/boiunatech:dev
        - docker run -p 8082:80 -e SenhaMySQLBoiuna=$SenhaMySQLBoiuna -e LoginAdminBoiuna=$LoginAdminBoiuna -e SenhaAdminBoiuna=$SenhaAdminBoiuna -e ServidorEmail=$ServidorEmail -e ServidorEmailPorta=$ServidorEmailPorta
            -e UsuarioServidorEmail=$UsuarioServidorEmail -e SenhaServidorEmail=$SenhaServidorEmail -e Usuario=$Usuario -e Servidor=192.168.69.2 -e BancoDeDados=boiuna_dev
            -v "/uploads_dev:/uploads" --name BoiunaDev -d registry.gitlab.com/trabalho3/pref-porto/boiunatech:dev
